% =================================================================================
% 
%   Demo of Weighted Coplanar Feature Clustering.
%
%   For details, please see our paper:
%   Z. Fang, et al. Jia. Superpixel Segmentation Using 
%   Weighted Coplanar Feature Clustering on RGBD Image. 
%   Appl. Sci.-Basel. 2018.
%
%   The code was tested in Intel-Mac (64bit).
%
%   Created by Zhuoqun Fang on May. 28, 2018.
% =================================================================================

rootdir = fullfile(pwd, 'data');
imgdir = fullfile(rootdir, 'image');
depthdir_fill = fullfile(rootdir, 'depth_fill');
normaldir = fullfile(rootdir, 'normal');
maskdir = fullfile(rootdir, 'mask');

% generate single data from database
i=1; %the order of the scene in NYU Depth Database--e.g., 800.
DBConvert(i);

% compute the superpixels
im = imread([imgdir, filesep, 'color' num2str(i,'%08d') '.png']);%load color image
load([depthdir_fill, filesep, 'depthfill' num2str(i,'%08d') '.mat'])%load filled depth image
nm = imread([normaldir, filesep, 'normal' num2str(i,'%08d') '.ppm']);%load normal image
nmdist = 255*dist_depth2(xx, yy, zz, nm);
[labels_ours, numlabels_ours] = wcfcmex(im,nmdist,900,8,2);

mask = imread([maskdir,filesep, 'mask', num2str(i,'%08d'), '.png']);
imp_ours = drawSuperpixels(im, labels_ours);
numlabels_ours2 = numlabels_ours*(1-sum(mask(:))/(640*480));
figure(1),imagesc(imp_ours); axis image off;title(['WCFC ' num2str(numlabels_ours2)]);